/*
 *  CheckArray.c
 *  Version 1.5.1 / 980127
 *  by Satoshi Takahashi
 */

#ifndef CHECKARRAY_C /*pragma once*/
#define CHECKARRAY_C
#include <s_Config.h>

#include <string.h>
#include <StartSCL.h>

#define S_CA_MAXARRAYNUM 20

#include <CheckArray.h>

#include <VarBody.h>
#include <CheckArray-v.c>


void in_RegisterArray(void *array, long limit1, long limit2, long limit3, long limit4,
						const char *name)
{
int i;

	i = FindArray(array);
	if ( i >= S_CA_MAXARRAYNUM)
	{
		s_printf("Error in in_RegisterArray:\nToo many arrays!\n");
		return;
	}
	s_ca.address[i] = array;
	s_ca.limit1[i] = limit1;
	s_ca.limit2[i] = limit2;
	s_ca.limit3[i] = limit3;
	s_ca.limit4[i] = limit4;
	strcpy(s_ca.name[i], name);
}

int FindArray(void *array)
{
int i;

	for (i=0; s_ca.address[i] && (s_ca.address[i] != array); i++);
	
	return i;
}

void in_CheckArray(void *array, long index1, long index2, long index3, long index4, char* position)
{
int i;

	i = FindArray(array);
	
	if (!s_ca.address[i])
	{
		s_printf("Array at %p is not registered\n", array);
		Stop();
		return;
	}
	
	if (index1 >= s_ca.limit1[i])
	{
		s_printf("Bug Found at %s!\n1st index %ld of %s is larger than limit %ld.\n", position,
					index1,  s_ca.name[i], s_ca.limit1[i]);
		Stop();
		return;
	}
	if (index2 >= s_ca.limit2[i])
	{
		s_printf("Bug Found at %s!\n2nd index %ld of %s is larger than limit %ld.\n", position,
					index2,  s_ca.name[i], s_ca.limit2[i]);
		Stop();
		return;
	}
	if (index3 >= s_ca.limit3[i])
	{
		s_printf("Bug Found at %s!\n3rd index %ld of %s is larger than limit %ld.\n", position,
					index3,  s_ca.name[i], s_ca.limit3[i]);
		Stop();
		return;
	}
	if (index4 >= s_ca.limit4[i])
	{
		s_printf("Bug Found at %s!\n4th index %ld of %s is larger than limit %ld.\n", position,
					index4,  s_ca.name[i], s_ca.limit4[i]);
		Stop();
		return;
	}
}

#endif /*pragma once*/