/*
 * DelayedSetParams.c
 *  Version 1.9.1 / 010223
 *  by Satoshi Takahashi
 */

#ifndef DELAYEDSETPARAMS_C
#define DELAYEDSETPARAMS_C
#include <s_Config.h>
#if S_CARBON
#include <Carbon/Carbon.h>
#endif

#include <stdlib.h>

#include <HugeArray.h>
#include <s_Common.h>

#include <DelayedSetParams.h>

#include <VarBody.h>
#include <DelayedSetParams-v.c>

void SetParamsIntArray(int **address, int index, int value, int group)
{
	if (!s_dsp.intArrayInit)
		DSPInitIntArray();
	if (s_dsp.intArrayCurNum >= s_dsp.intArrayTotalNum)
		PrintError("Too many initializing parameters!  \
Use SetParamsNum to expand initializing parameters number.");
	
	s_dsp.intArrayAddr[s_dsp.intArrayCurNum] = address;
	s_dsp.intArrayIndex[s_dsp.intArrayCurNum] = index;
	s_dsp.intArrayValue[s_dsp.intArrayCurNum] = value;
	s_dsp.intArrayGroup[s_dsp.intArrayCurNum] = group;
	
	s_dsp.intArrayCurNum++;
}


void DSPInitIntArray(void)
{
		s_dsp.intArrayInit = 1;
		s_dsp.intArrayAddr = CheckCalloc(s_dsp.intArrayTotalNum, sizeof(int **));
		s_dsp.intArrayIndex = CheckCalloc(s_dsp.intArrayTotalNum, sizeof(int));
		s_dsp.intArrayValue = CheckCalloc(s_dsp.intArrayTotalNum, sizeof(int));
		s_dsp.intArrayGroup = CheckCalloc(s_dsp.intArrayTotalNum, sizeof(int));
}


void DelaySetParamsIntArray(int maxIndex, int group)
{
int i;

	if (!s_dsp.intArrayInit)
		return;

	for (i = 0; i < s_dsp.intArrayTotalNum; i++)
	{
		if (s_dsp.intArrayGroup[i] == group &&
			s_dsp.intArrayIndex[i] >= 0 && s_dsp.intArrayIndex[i] < maxIndex)
			(*s_dsp.intArrayAddr[i])[s_dsp.intArrayIndex[i]] = s_dsp.intArrayValue[i];
	}
}


void SetParamsDoubleArray(double **address, int index, double value, int group)
{
	if (!s_dsp.doubleArrayInit)
		DSPInitDoubleArray();
	if (s_dsp.doubleArrayCurNum >= s_dsp.doubleArrayTotalNum)
		PrintError("Too many initializing parameters!  \
Use SetParamsNum to expand initializing parameters number.");
	
	s_dsp.doubleArrayAddr[s_dsp.doubleArrayCurNum] = address;
	s_dsp.doubleArrayIndex[s_dsp.doubleArrayCurNum] = index;
	s_dsp.doubleArrayValue[s_dsp.doubleArrayCurNum] = value;
	s_dsp.doubleArrayGroup[s_dsp.doubleArrayCurNum] = group;
	
	s_dsp.doubleArrayCurNum++;
}


void DSPInitDoubleArray(void)
{
		s_dsp.doubleArrayInit = 1;
		s_dsp.doubleArrayAddr = CheckCalloc(s_dsp.doubleArrayTotalNum, sizeof(double **));
		s_dsp.doubleArrayIndex = CheckCalloc(s_dsp.doubleArrayTotalNum, sizeof(int));
		s_dsp.doubleArrayValue = CheckCalloc(s_dsp.doubleArrayTotalNum, sizeof(double));
		s_dsp.doubleArrayGroup = CheckCalloc(s_dsp.doubleArrayTotalNum, sizeof(int));
}


void DelaySetParamsDoubleArray(int maxIndex, int group)
{
int i;

	if (!s_dsp.doubleArrayInit)
		return;

	for (i = 0; i < s_dsp.doubleArrayTotalNum; i++)
	{
		if (s_dsp.doubleArrayGroup[i] == group &&
			s_dsp.doubleArrayIndex[i] >= 0 && s_dsp.doubleArrayIndex[i] < maxIndex)
			(*s_dsp.doubleArrayAddr[i])[s_dsp.doubleArrayIndex[i]] = s_dsp.doubleArrayValue[i];
	}
}

void SetDelayParamsNum(int num)
{
	s_dsp.intArrayTotalNum = num;
	s_dsp.doubleArrayTotalNum = num;
}
#endif /*pragma once*/
