/*
 *  DragAndDrop.c
 *  Version 1.5.2 / 980323
 *  by Satoshi Takahashi
 */

#ifndef DRAGANDDROP_C /*pragma once*/
#define DRAGANDDROP_C

#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif

#include <stdio.h>

#ifndef SCLLocal
#include <s_String.h>

#include <DragAndDrop.h>
#include <VarBody.h>
#include <DragAndDrop-v.c>
#else
#include "s_String.h"

#include "DragAndDrop.h"
#include "VarBody.h"
#include "DragAndDrop-v.c"
#endif


int DDCount(void)
{
#if !S_UNIX
	return s_dd.fileTotal - s_dd.curFile;
#else
	return 0;
#endif
}

FILE *DDFOpen(const char* filename, const char* mode)
{
#if S_CARBON
FSRef fsr;
char path[1024];
#else /*S_CARBON*/
short vRefNum;
long dirID;
FILE *filep;
char fileName[64];
#endif /*else S_CARBON*/

	if (s_dd.curFile >= s_dd.fileTotal)
		return 0;

	s_dd.fss = DDFSSpec();

#if S_CARBON
	FSpMakeFSRef(&s_dd.fss, &fsr);
	FSRefMakePath(&fsr, path, 1024);
	return fopen(path, mode);
#else /*S_CARBON*/
	HGetVol(NULL, &vRefNum, &dirID);
	HSetVol(NULL, s_dd.fss.vRefNum, s_dd.fss.parID);

	P2CString(s_dd.fss.name, fileName);
	filep = fopen(fileName, mode);
	
	HSetVol(NULL, vRefNum, dirID);
	
	return filep;
#endif /*else S_CARBON*/
}

FSSpec DDFSSpec(void)
{
OSErr err;
Size actualSize;
AEKeyword keywd;
DescType returnedType;

FSSpec fss = {0,0,{0}};

	if (s_dd.curFile >= s_dd.fileTotal)
		return fss;
	
	s_dd.curFile++;

	err = AEGetNthPtr(&s_dd.docList, s_dd.curFile, typeFSS,
		&keywd, &returnedType,
		(Ptr)&fss, sizeof(FSSpec), &actualSize);

	return fss;
}


#endif /*pragma once*/