/*
 *  Formula.h
 *  Version 1.4.3 / 971121
 *  by Satoshi Takahashi
 */
 

#ifndef FORMULA_H  /*pragma once*/
#define FORMULA_H


/*********************************** Switches ***********************************/

#include <Formula-Switches.h>

/****************************** Constants ********************************/

#include <Formula-Consts.h>


/***************************** Formula Types ***********************************/

#include <Formula-v.h>


/************************* FORMULASHELLL and help *****************************/

void FormulaShell(void);
void WaitReturn(void);
void FormulaHelp(void);


/***************************** Formula IO ***********************************/

#include <Formula-IO.h>


/**************************** Formula Calc **********************************/

#include <Formula-Calc.h>


/**************************** Formula Utilities **********************************/

#include <Formula-Utilities.h>


/********************************* Other **************************************/


void SetDecimalDigit(void);
void SetRightMargin(void);
void SetDivLevel(void);

void FormulaComment(void);

int CheckComment(char *str);

void OneLineComment(void);

void SetFlag(int *flagP);

void	SetUpFormula(void);

void ErrorIlegalCommand(void);
void ErrorAmbiguousCommand(void);

voidFunc *SelectCommand(char *commandString);
int StringCoincideLength(char *string1, char *string2);


void SetDisplayFlag(void);
void SetGCFlag(void);
void SetTimeFlag(void);
#if TEST_SC
void SetShowCommandFlag(void);
#endif
void ShowMemory(void);
void SelectFormula(void);
void CoefFormula(void);
void QuitFormula(void);
void SetSymbolMax(void);
void SetFormulaMax(void);

#endif /*pragma once*/
