/*
 *  Graph1D.h
 *  Version 1.8 / 000825
 *  by Satoshi Takahashi, Hidekazu Koike, Tomohiro Mizuno and Yumiko Takahashi
 */

#ifndef GRAPH1D_H /*pragma once*/
#define GRAPH1D_H
#include <s_Config.h>


#include <stdio.h>
#include <ParametersDialog.h>

#define APPEND_LAST1D 0

#define S_FG_MAXFUNCNUM 10

#define fType 0
#define xyType 1
#define spreadSheetType 10

#include <VarHeader.h>
#include <Graph1D-v.c>

void FunctionGraph(void);
void XYFunctionGraph(void);

void DrawGraph(void);
void GraphAddParameters(void);
void GraphAddparametersXYFunc(void);

void GraphPlotFunction(void);
double GraphPlotFuctionOneSeries(int i);
void GraphPlotFuctionOneBar(double x, int i);
double GraphPlotXYFuctionOneSeries(int i);

void SetGraphFunction(double (*)(double));
void AddGraphFunction(double (*)(double));
void SetGraphXYFunction(double (*fx)(double),double (*fy)(double));
void AddGraphXYFunction(double (*fx)(double),double (*fy)(double));
#define SetFGFunction SetGraphFunction
#define SetFGXYFunction SetGraphXYFunction
#define AddFGFunction AddGraphFunction

void SetGraphMinDrawX(double d);
void SetGraphMaxDrawX(double d);

void SetGraphUserProc(void (*userProc)(void));

void Graph1DRegressionLine(int xSeries, int ySeries);

#define Graph1DAddParameter(p,type,com) in_Graph1DAddParameter((Ptr)p,type,com)
void in_Graph1DAddParameter(Ptr p,int type,char* com);

#endif /*pragma once*/
