/*
 *  GraphSpreadSheet.h
 *  Version 1.9.1 / 010220
 *  by Satoshi Takahashi
 */

#ifndef GRAPHSPREADSHEET_H /*pragma once*/
#define GRAPHSPREADSHEET_H

#include <VarHeader.h>
#include <GraphSpreadSheet-v.c>

void SpreadSheetGraph(void);
void GraphPlotSpreadSheet(void);
void PlotSpreadSheetOneSeries(int xSeries, int ySeries, int stdDevSeries, 
								double pen, double radius, int nolinefrag, int cirlefrag,
								double plotSeriesMin, double plotSeriesMax);
void StdDevBar(int xSeries, int ySeries, int stdDevSeries, int dataNumber);

void SGInit(void);
void SGSS1DAddParameters(void);

void SetGraphDataNumber(long data_number);
void SetGraphMaxSeriesNumber(int seriesNumber);

void SetGraphFileName(const char* fName);
#define SetSGFileName SetGraphFileName

void SetGraphRegressionLineFlag(int flag);
void SetGraphShowGradientFlag(int flag);
void SetGraphGradientFontSize(int fontsize);

void SetGraphLogXFlag(int flag);
void SetGraphLogYFlag(int flag);

void SetGraphShowDataFlag(int flag);

void SetGraphSeriesX(int i, int series);
void SetGraphSeriesY(int i, int series);
void SetGraphSeriesF(int i, int series);
void SetGraphSeriesStdDev(int i, int series);
void SetGraphPenWidth(int i, double pen);
void SetGraphNoLine(int i, int noLine);
void SetGraphDataMark(int i, int dataMark);
void SetGraphRadius(int i, int radius);

double GraphConvertX(double x);
double GraphConvertY(double y);


/********** 2D **********/
void Graph2DSS(void);
double Graph2DSSFunc(double x, double y);
void SG2DInit(void);
void SGSeriesRange(void);
void SG2DArray(void);

/*********** 3D **********/
void Graph3DSS(void);
void SG3DInit(void);

#endif /*pragma once*/