/*
 *  PDProcs.c
 *  Version 1.7 / 980807
 *  by Satoshi Takahashi
 */

#ifndef PDPROCS_C
#define PDPROCS_C
#include <s_Config.h>

#include <PDProcs.h>
#include <StartSCL.h>
#include <Save.h>
#include <s_Print.h>
#include <Plot.h>
#include <ParametersDialog.h>

void AddPDProcs(void)
{
	AddParameter(&ShowProc,doType,"Show");
	AddParameter(&ClearProc,doType,"Clear");
	AddParameter(&PrintProc,doType,"Print BitMap");
	AddParameter(&SaveProc,doType,"Save BitMap");
	AddParameter(&BeginPrintingProc,doType,"Begin Printing");
	AddParameter(&EndPrintingProc,doType,"End Printing");
	AddParameter(&BeginSavingProc,doType,"Begin Saving");
	AddParameter(&EndSavingProc,doType,"End Saving");
	AddParameter(&EndSavingInPrintingProc,doType,"Save Printing");
#if !S_UNIX
	AddParameter(&EnlargePlot2D,doType,"Magnify");
#endif
	AddParameter(&ShrinkProc,doType,"Shrink Half");
}

void SaveProc()
{
	BeginBitMapSaving();
#if !S_UNIX && !S_CARBON
	RedrawDrawing();
#endif /*!S_UNIX*/
	EndBitMapSaving();
}

void PrintProc()
{
	BeginBitMapPrinting();
#if !S_UNIX && !S_CARBON
	RedrawDrawing();
#endif /*!S_UNIX*/
	EndBitMapPrinting();
}

void ShowProc()
{
#if !S_UNIX
#if !S_CARBON
	RedrawDrawing();
#endif /*S_CARBON*/
	Stop();
#endif /*!S_UNIX*/
}

void ClearProc()
{
#if !S_UNIX
	EraseDrawing();
#endif /*!S_UNIX*/
}

void BeginSavingProc()
{
#if !S_UNIX
	BeginSaving();
#endif /*!S_UNIX*/
}

void EndSavingProc()
{
#if !S_UNIX
	EndSaving();
#endif /*!S_UNIX*/
}

void BeginPrintingProc()
{
#if !S_UNIX
	BeginPrinting();
#endif /*!S_UNIX*/
}

void EndPrintingProc()
{
#if !S_UNIX
	EndPrinting();
#endif /*!S_UNIX*/
}

void EndSavingInPrintingProc()
{
#if !S_UNIX
	SavePict(s_print.pict);
#endif /*!S_UNIX*/
}

void ShrinkProc(void)
{
#if !S_UNIX
	ShrinkPlot2D(2.0);
#endif /*!S_UNIX*/
}

#endif /*pragma once*/
