/*
 *  SCLDrawingFile.h
 *  Version 1.5 / 980105
 *  by Satoshi Takahashi, Yumiko Takahashi & Hidekazu Koike
 */

#ifndef SCL_DRAWING_FILE_H /*pragma once*/
#define SCL_DRAWING_FILE_H
#include <s_Config.h>
#if !UNIX

#include <stdio.h>

typedef struct
{
	FILE *fp;
	int maxLineNum;
	char oneLine[1024];
	char stopString[64];
	int skipLines;
	char lastString[64];
	Rect r;
} s_sdfType;

extern s_sdfType s_sdf;

typedef void (voidStringFunc)(char*);

/******************** DrawSCLFile ********************/
void DrawSCLFile(void);
void SkipDF(void);
void DoDrawCommand(char *oneLine);
voidStringFunc *SDFSelectCommand(char *commandString);

void DummyVoidString(char *inputLine);
void DoMoveTo(char *inputLine);

/******************** Line ********************/
void DoLineTo(char *inputLine);
void DoPenSize(char *inputLine);
void DoEraseDrawing(char *inputLine);

/******************** Rect ********************/
void DoSetRect(char *inputLine);
void DoFrameRect(char *inputLine);
void DoPaintRect(char *inputLine);
void DoEraseRect(char *inputLine);
void DoInvertRect(char *inputLine);

/******************** Oval ********************/
void DoFrameOval(char *inputLine);
void DoPaintOval(char *inputLine);
void DoEraseOval(char *inputLine);
void DoInvertOval(char *inputLine);

/******************** DrawText ********************/
void DoDrawText(char *inputLine);

/******************** Save ********************/
void DoBeginBitMapSaving(char *inputLine);
void DoEndBitMapSaving(char *inputLine);
void DoBeginPlotSaving(char *inputLine);
void DoEndPlotSaving(char *inputLine);
void DoBeginSaving(char *inputLine);
void DoEndSaving(char *inputLine);

#endif /*!UNIX*/
#endif /*pragma once*/