/*
 *  SCLXResource.c
 *  Version 2.0 / 010824
 *  by Satoshi Takahashi
 */

#ifndef SCLXRESOURCE_C
#define SCLXRESOURCE_C

#include <s_Toolbox.h>
#include <SCLXResource.h>

enum DialogPosition
{
	noAutoCenter = 0x0000, centerMainScreen = 0x280a,
	alertPositionMainScreen = 0x300a, staggerMainScreeen = 0x380a,
	centerParenWindow = 0xa80a, alertPositionParenWindow = 0xb00a,
	staggerParenWindow = 0xb80a, centerParenWindowScreen = 0x680a,
	alertPosionParenWindowScreen = 0x700a,
	staggerParenWindowScreen = 0x780a,
};

SXDialogResourceItem SXDialogResource[] =
{
/*	{ resID, {{ top, left, bottom, right}, procID, visible, goAway,
			refCon, ID, title, position}, itemCount}, */
	{ 	  1, {{  100, 150,    400,   450},	dBoxProc,  1,	  0,
			0,		128, "", alertPositionMainScreen},  39},
	{ 	  2, {{  100, 150,    450,   450},	dBoxProc,  1,	  0,
			0,		128, "", alertPositionMainScreen},  51},
	{ 	128, {{  100,  50,    400,   450},	dBoxProc,  1,	  0,
			0,		128, "", alertPositionMainScreen},  57},
	/* 0 ends the list */
	{ 	  0, {{   0,    0,      0,     0},	       0,  0,	  0,
			0,		  0, "",                        0},  0}, 
};

DITLItem SXDItemResource[] =
{													
/*	{ resID, itemID, itmHndl, { top, left, bottom, right},
				  itmType,    itmData{value, label},
		 inited, widget, dialog, NCFlag, optWidget}, */
	{     1,	  1, 		0, { 265,  230,    295,   290},
		kButtonDialogItem, {0, "Open"},
		      0,      0,	  0,	 0,			0},
	{     1,	  2, 		0, { 215,  230,    245,   290},
		kButtonDialogItem, {0, "Cancel"},
		      0,      0,	  0,	 0,			0},
	{     1,	  3, 		0, { 125,  230,    155,   290},
		kButtonDialogItem, {0, "Root"},
		      0,      0,	  0,	 0,			0},
	{     1,	  4, 		0, {  75,  230,    105,   290},
		kButtonDialogItem, {0, "Up"},
		      0,      0,	  0,	 0,			0},
	{     1,	  5, 		0, { 275,  200,    295,   220},
		kResourceControlDialogItem, {rDownArrowDialogItem, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  6, 		0, {  55,  200,    75,   220},
		kResourceControlDialogItem, {rUpArrowDialogItem, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  7, 		0, {  10,  10,    40,   290},
		kStaticTextDialogItem, {1, "Path will appear here.  Maybe in\nmultiple lines.  But it does not break as long as it has no line-break characters, so this line never breaks.................. OK?"},
		      0,      0,	  0,	 0,			0},
	{     1,	  8, 		0, {  55,  10,    69,   180},
		kRadioButtonDialogItem, {1, "File 1"},
		      0,      0,	  0,	 0,			0},
	{     1,	  9, 		0, {  55,  185,    69,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  10, 		0, {  70,  10,    84,   180},
		kRadioButtonDialogItem, {1, "File 2"},
		      0,      0,	  0,	 0,			0},
	{     1,	  11, 		0, {  70,  185,    84,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  12, 		0, {  85,  10,    99,   180},
		kRadioButtonDialogItem, {1, "Directory 1"},
		      0,      0,	  0,	 0,			0},
	{     1,	  13, 		0, {  85,  185,    99,   195},
		kStaticTextDialogItem, {0, "/"},
		      0,      0,	  0,	 0,			0},
	{     1,	  14, 		0, {  100,  10,    114,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  15, 		0, {  100,  185,    114,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  16, 		0, {  115,  10,    129,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  17, 		0, {  115,  185,   129,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  18, 		0, {  130,  10,    144,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  19, 		0, {  130,  185,    144,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  20, 		0, {  145,  10,    159,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  21, 		0, {  145,  185,    159,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  22, 		0, {  160,  10,    174,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  23, 		0, {  160,  185,    174,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  24, 		0, {  175,  10,    189,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  25, 		0, {  175,  185,    189,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  26, 		0, {  190,  10,    204,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  27, 		0, {  190,  185,    204,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  28, 		0, {  205,  10,    219,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  29, 		0, {  205,  185,   219,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  30, 		0, {  220,  10,    234,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  31, 		0, {  220,  185,   234,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  32, 		0, {  235,  10,    249,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  33, 		0, {  235,  185,   249,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  34, 		0, {  250,  10,    264,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  35, 		0, {  250,  185,   264,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  36, 		0, {  265,  10,    279,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  37, 		0, {  265,  185,   279,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     1,	  38, 		0, {  280,  10,    294,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     1,	  39, 		0, {  280,  185,   294,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  1, 		0, { 315,  230,    345,   290},
		kButtonDialogItem, {0, "Save"},
		      0,      0,	  0,	 0,			0},
	{     2,	  41, 		0, { 315,  10,    345,   200},
		kResourceControlDialogItem, {rSimpleEditTextDialogItem, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  40, 		0, { 265,  230,    295,   290},
		kButtonDialogItem, {0, "Open"},
		      0,      0,	  0,	 0,			0},
	{     2,	  2, 		0, { 215,  230,    245,   290},
		kButtonDialogItem, {0, "Cancel"},
		      0,      0,	  0,	 0,			0},
	{     2,	  3, 		0, { 125,  230,    155,   290},
		kButtonDialogItem, {0, "Root"},
		      0,      0,	  0,	 0,			0},
	{     2,	  4, 		0, {  75,  230,    105,   290},
		kButtonDialogItem, {0, "Up"},
		      0,      0,	  0,	 0,			0},
	{     2,	  5, 		0, { 275,  200,    295,   220},
		kResourceControlDialogItem, {rDownArrowDialogItem, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  6, 		0, {  55,  200,    75,   220},
		kResourceControlDialogItem, {rUpArrowDialogItem, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  7, 		0, {  10,  10,    40,   290},
		kStaticTextDialogItem, {1, "Path will appear here.  Maybe in\nmultiple lines.  But it does not break as long as it has no line-break characters, so this line never breaks.................. OK?"},
		      0,      0,	  0,	 0,			0},
	{     2,	  8, 		0, {  55,  10,    69,   180},
		kRadioButtonDialogItem, {1, "File 1"},
		      0,      0,	  0,	 0,			0},
	{     2,	  9, 		0, {  55,  185,    69,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  10, 		0, {  70,  10,    84,   180},
		kRadioButtonDialogItem, {1, "File 2"},
		      0,      0,	  0,	 0,			0},
	{     2,	  11, 		0, {  70,  185,    84,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  12, 		0, {  85,  10,    99,   180},
		kRadioButtonDialogItem, {1, "Directory 1"},
		      0,      0,	  0,	 0,			0},
	{     2,	  13, 		0, {  85,  185,    99,   195},
		kStaticTextDialogItem, {0, "/"},
		      0,      0,	  0,	 0,			0},
	{     2,	  14, 		0, {  100,  10,    114,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  15, 		0, {  100,  185,    114,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  16, 		0, {  115,  10,    129,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  17, 		0, {  115,  185,   129,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  18, 		0, {  130,  10,    144,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  19, 		0, {  130,  185,    144,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  20, 		0, {  145,  10,    159,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  21, 		0, {  145,  185,    159,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  22, 		0, {  160,  10,    174,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  23, 		0, {  160,  185,    174,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  24, 		0, {  175,  10,    189,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  25, 		0, {  175,  185,    189,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  26, 		0, {  190,  10,    204,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  27, 		0, {  190,  185,    204,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  28, 		0, {  205,  10,    219,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  29, 		0, {  205,  185,   219,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  30, 		0, {  220,  10,    234,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  31, 		0, {  220,  185,   234,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  32, 		0, {  235,  10,    249,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  33, 		0, {  235,  185,   249,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  34, 		0, {  250,  10,    264,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  35, 		0, {  250,  185,   264,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  36, 		0, {  265,  10,    279,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  37, 		0, {  265,  185,   279,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{     2,	  38, 		0, {  280,  10,    294,   180},
		kRadioButtonDialogItem, {1, ""},
		      0,      0,	  0,	 0,			0},
	{     2,	  39, 		0, {  280,  185,   294,   195},
		kStaticTextDialogItem, {0, " "},
		      0,      0,	  0,	 0,			0},
	{   128,	  1, 		0, { 275,  330,    295,   390},
		kButtonDialogItem, {0, "Continue"},
		      0,      0,	  0,	 0,			0},
	/* 2 is frame around Continue Button */
	{   128,	  3, 		0, { 275,   10,    295,    70},
		kButtonDialogItem, {0, "Quit"},
		      0,      0,	  0,	 0,			0},
#define SXRt 5
#define SXRx1 5
#define SXRy1 20
#define SXRw1 115
#define SXRh1 14
#define SXRs 5
#define SXRw2 70
#define SXRc 200
#include "PDItemResource1.c"
	{   128,	 56, 		0, { 275,   150,    295,   190},
		kButtonDialogItem + kItemDisableBit,
							 {0, "<<"},
		       0,      0,	  0,	 0,			0},
	{   128,	 57, 		0, { 275,   210,    295,   250},
		kButtonDialogItem + kItemDisableBit,
							 {0, ">>"},
		          0,      0,	 0,		 0},
	{     0,	  0,	  0,   {   0,    0,      0,     0},
						0,     {0, ""},
		       0,      0,	  0,	 0,			0},
};

SXDItemArgItem SXDItemArgList[] =
{
	{SXDLOGStart, 1},
	{SXItemBegin, 1},
	{XtNborderWidth, 3},
	{SXItemEnd, 1},
	{SXItemBegin, 2},
	{SXItemEnd, 2},
	{SXItemBegin, 3},
	{SXItemEnd, 3},
	{SXItemBegin, 4},
	{SXItemEnd, 4},
	{SXItemBegin, 5},
	{SXItemEnd, 5},
	{SXItemBegin, 6},
	{SXItemEnd, 6},
	{SXItemBegin, 7},
	{SXItemEnd, 7},
	{SXItemBegin, 8},
	{SXItemEnd, 8},
	{SXItemBegin, 9},
	{SXItemEnd, 9},
	{SXItemBegin, 10},
	{SXItemEnd, 10},
	{SXItemBegin, 11},
	{SXItemEnd, 11},
	{SXItemBegin, 12},
	{SXItemEnd, 12},
	{SXItemBegin, 13},
	{SXItemEnd, 13},
	{SXItemBegin, 14},
	{SXItemEnd, 14},
	{SXItemBegin, 15},
	{SXItemEnd, 15},
	{SXItemBegin, 16},
	{SXItemEnd, 16},
	{SXItemBegin, 17},
	{SXItemEnd, 17},
	{SXItemBegin, 18},
	{SXItemEnd, 18},
	{SXItemBegin, 19},
	{SXItemEnd, 19},
	{SXItemBegin, 20},
	{SXItemEnd, 20},
	{SXItemBegin, 21},
	{SXItemEnd, 21},
	{SXItemBegin, 22},
	{SXItemEnd, 22},
	{SXItemBegin, 23},
	{SXItemEnd, 23},
	{SXItemBegin, 24},
	{SXItemEnd, 24},
	{SXItemBegin, 25},
	{SXItemEnd, 25},
	{SXItemBegin, 26},
	{SXItemEnd, 26},
	{SXItemBegin, 27},
	{SXItemEnd, 27},
	{SXItemBegin, 28},
	{SXItemEnd, 28},
	{SXItemBegin, 29},
	{SXItemEnd, 29},
	{SXItemBegin, 30},
	{SXItemEnd, 30},
	{SXItemBegin, 31},
	{SXItemEnd, 31},
	{SXItemBegin, 32},
	{SXItemEnd, 32},
	{SXItemBegin, 33},
	{SXItemEnd, 33},
	{SXItemBegin, 34},
	{SXItemEnd, 34},
	{SXItemBegin, 35},
	{SXItemEnd, 35},
	{SXItemBegin, 36},
	{SXItemEnd, 36},
	{SXItemBegin, 37},
	{SXItemEnd, 37},
 	{SXItemBegin, 38},
	{SXItemEnd, 38},
	{SXItemBegin, 39},
	{SXItemEnd, 39},
	{SXDLOGEnd, 1},
	{SXDLOGStart, 2},
	{SXItemBegin, 1},
	{XtNborderWidth, 3},
	{SXItemEnd, 1},
	{SXItemBegin, 2},
	{SXItemEnd, 2},
	{SXItemBegin, 3},
	{SXItemEnd, 3},
	{SXItemBegin, 4},
	{SXItemEnd, 4},
	{SXItemBegin, 5},
	{SXItemEnd, 5},
	{SXItemBegin, 6},
	{SXItemEnd, 6},
	{SXItemBegin, 7},
	{SXItemEnd, 7},
	{SXItemBegin, 8},
	{SXItemEnd, 8},
	{SXItemBegin, 9},
	{SXItemEnd, 9},
	{SXItemBegin, 10},
	{SXItemEnd, 10},
	{SXItemBegin, 11},
	{SXItemEnd, 11},
	{SXItemBegin, 12},
	{SXItemEnd, 12},
	{SXItemBegin, 13},
	{SXItemEnd, 13},
	{SXItemBegin, 14},
	{SXItemEnd, 14},
	{SXItemBegin, 15},
	{SXItemEnd, 15},
	{SXItemBegin, 16},
	{SXItemEnd, 16},
	{SXItemBegin, 17},
	{SXItemEnd, 17},
	{SXItemBegin, 18},
	{SXItemEnd, 18},
	{SXItemBegin, 19},
	{SXItemEnd, 19},
	{SXItemBegin, 20},
	{SXItemEnd, 20},
	{SXItemBegin, 21},
	{SXItemEnd, 21},
	{SXItemBegin, 22},
	{SXItemEnd, 22},
	{SXItemBegin, 23},
	{SXItemEnd, 23},
	{SXItemBegin, 24},
	{SXItemEnd, 24},
	{SXItemBegin, 25},
	{SXItemEnd, 25},
	{SXItemBegin, 26},
	{SXItemEnd, 26},
	{SXItemBegin, 27},
	{SXItemEnd, 27},
	{SXItemBegin, 28},
	{SXItemEnd, 28},
	{SXItemBegin, 29},
	{SXItemEnd, 29},
	{SXItemBegin, 30},
	{SXItemEnd, 30},
	{SXItemBegin, 31},
	{SXItemEnd, 31},
	{SXItemBegin, 32},
	{SXItemEnd, 32},
	{SXItemBegin, 33},
	{SXItemEnd, 33},
	{SXItemBegin, 34},
	{SXItemEnd, 34},
	{SXItemBegin, 35},
	{SXItemEnd, 35},
	{SXItemBegin, 36},
	{SXItemEnd, 36},
	{SXItemBegin, 37},
	{SXItemEnd, 37},
 	{SXItemBegin, 38},
	{SXItemEnd, 38},
	{SXItemBegin, 39},
	{SXItemEnd, 39},
	{SXItemBegin, 40},
	{SXItemEnd, 40},
	{SXItemBegin, 41},
	{SXItemEnd, 41},
	{SXDLOGEnd, 2},
	{SXDLOGStart, 128},
	{SXItemBegin, 1},
	{XtNborderWidth, 3},
	{SXItemEnd, 1},
	/* item 2 is a frame around Continue button */
	{SXItemBegin, 3},
	{SXItemEnd, 3},
#if 0
	{SXItemBegin, 4},
	{SXItemEnd, 4},
	{SXItemBegin, 5},
	{SXItemEnd, 5},
	{SXItemBegin, 6},
	{SXItemEnd, 6},
	{SXItemBegin, 7},
	{SXItemEnd, 7},
	{SXItemBegin, 8},
	{SXItemEnd, 8},
	{SXItemBegin, 9},
	{SXItemEnd, 9},
#endif
	{SXDLOGEnd, 128},
	{SXDItemArgListEnd, 0},
};

#endif /*pragma once*/
