/*
 *  s_Drawing.c
 *  Version 2.0 / 000920
 *  by Satoshi Takahashi
 */

#ifndef S_DRAWINGL_C /*pragma once*/
#define S_DRAWINGL_C
#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif
#if S_CARBON
#include <Carbon/Carbon.h>
#endif

#include <stdlib.h> /* NewPtr */
#if S_UNIX /* as s_UNIX.h is not in parts-main */
#include <s_UNIX.h>
#endif

#ifndef SCLLocal
#include <StartSCL.h>
#include <s_undef.c>


#if !S_UNIX && !S_CARBON
#include <QDOffScreen.h>
#endif /*!S_UNIX && !S_CARBON*/

#include <s_RedrawFunc.h>

#include <s_Carbon.h>
#include <s_CarbonMacro.h>
#include <s_Drawing.h>
#else /*SCLLocal*/
#include "StartSCL.h"
#include "s_undef.c"


#if !S_UNIX && !S_CARBON
#include "QDOffScreen.h"
#endif /*!S_UNIX && !S_CARBON*/

#include "s_RedrawFunc.h"

#include "s_Carbon.h"
#include "s_CarbonMacro.h"
#include "s_Drawing.h"
#endif /*else SCLLocal*/

extern int s_redrawFlag;

int s_colorFlag = 0;

#if S_CARBON
Rect			s_windowBounds = {23, 250, 540, 800};
#elif !S_UNIX
Rect			s_windowBounds = { 20, 190, 520, 690};
#else
Rect			s_windowBounds = { 0, 290, 500, 790};
#endif
WindowPtr		s_redrawWindow;
Rect			s_drawingBounds;
Rect			s_redrawBounds;

#if SCL_USE_WINDOW
#if !S_UNIX
GDHandle s_display;
#endif
double				s_d_scale = 1.0;
#endif /*SCL_USE_WINDOW*/

#if !S_UNIX /******************** !!!! UNIX ********************/

void s_SetGWorld(GrafPtr port,GDHandle gdh)
{
	if(s_colorFlag)
	{
		SetGWorld((CGrafPtr)port,gdh);
	}
	else
	{
		SetPort(port);
	}
}

void s_GetGWorld(GrafPtr* port,GDHandle* gdh)
{
	if(s_colorFlag)
	{
		GetGWorld((CGrafPtr*)port,gdh);
	}
	else
	{
		GetPort(port);
	}
}

Rect s_drawingVisRect;

void s_CustomizeQDProcs(void);

#endif /*!S_UNIX*/ /******************** UNIX ********************/

void InitDrawing(void)
{
#if S_CARBON
//Rect *pr;
    s_NoRedrawInitDrawing();
    /* to fix Carbon bug? My mistake!*/
    //pr = SCWindowBounds(s_drawingWindow);
    //OffsetRect(pr, - pr->left, - pr->top);
    s_CustomizeQDProcs();
    return;
#else /*S_CARBON*/
    s_RedrawInitDrawing();
#endif /*else S_CARBON*/
}


void s_RedrawInitDrawing(void)
{
#if !S_UNIX
short s_fontNum=4;
short	err;
GWorldPtr currPort;

	s_ss.initDrawingFlag = 1;

	RedrawWindowP = &s_redrawWindow;

	SetRect(&s_redrawBounds, s_windowBounds.left*s_d_scale, s_windowBounds.top*s_d_scale,
		s_windowBounds.right*s_d_scale, s_windowBounds.bottom*s_d_scale);
	if (s_colorFlag)
	{
		s_redrawWindow=NewCWindow(nil, &s_redrawBounds,
			(unsigned char *)"\pDrawing", true, altDBoxProc, (WindowPtr)-1L, true, 0);
	}
	else
	{
		s_redrawWindow=NewWindow(nil,&s_redrawBounds,
			(unsigned char *)"\pDrawing",true,altDBoxProc,(WindowPtr)-1L,true,0);
	}

	s_drawingBounds=s_windowBounds;
	s_drawingVisRect=s_windowBounds;
#if 1
	s_drawingVisRect.right -= s_drawingVisRect.left;
	s_drawingVisRect.bottom -= s_drawingVisRect.top;
	s_drawingVisRect.left=0;
	s_drawingVisRect.top=0;
#endif
//	s_printf("%d\n",s_drawingBounds.right);
	s_drawingBounds.right += s_drawingBounds.left;
//	s_printf("%d\n",s_drawingBounds.right);
	OffsetRect(&s_drawingBounds,-s_drawingBounds.left,-s_drawingBounds.top);
	if (s_colorFlag)
	{
		GetGWorld(&currPort,&s_display);
		if(err = NewGWorld((GWorldPtr*)&s_drawingWindow, 0, &s_windowBounds, nil, nil, 0))
		{
			switch (err)
			{
				case -108:s_printf("Out of Memory !!");
					break;
				default:s_printf("Error in creating offscreen:%hd",err);
			}
			Stop();
			ExitToShell();
		}
		//NoPurgePixels(((CGrafPtr)s_drawingWindow)->portPixMap);
		NoPurgePixels(GetPortPixMap(GetWindowPort(s_drawingWindow)));
		//LockPixels(((CGrafPtr)s_drawingWindow)->portPixMap);
		LockPixels(GetPortPixMap(GetWindowPort(s_drawingWindow)));
#if 0
		s_drawingVisRect.right -= s_windowBounds.left;
#endif
		SetGWorld((CGrafPtr)s_drawingWindow,nil);
	}
#if !S_CARBON
	else
	{
		s_drawingWindow=(GrafPtr)NewPtr(sizeof(GrafPort));
		OpenPort(s_drawingWindow);
		s_drawingWindow->portRect=s_drawingBounds;
#if 0
		s_drawingVisRect = s_drawingBounds;
		s_drawingVisRect.right -= s_windowBounds.left;
#endif
		s_drawingWindow->portBits.bounds=s_drawingBounds;
		RectRgn(s_drawingWindow->clipRgn,&s_drawingBounds);
		RectRgn(s_drawingWindow->visRgn,&s_drawingBounds);
		s_drawingWindow->portBits.rowBytes=
				((s_drawingBounds.right-s_drawingBounds.left+15)>>4)<<1;
		if(!(s_drawingWindow->portBits.baseAddr=
				NewPtr((s_drawingWindow->portBits.rowBytes)*
							(long)(s_drawingWindow->portRect.bottom
							-s_drawingWindow->portRect.top))))
		{
			s_debug("Out of Memory!!!");
			ExitToShell();
		}
	}
#endif /*!S_CARBON*/

	EraseRect(SCWindowBounds(s_drawingWindow));

	s_CustomizeQDProcs();


	BeginUpdate(s_redrawWindow);
	EndUpdate(s_redrawWindow);

	s_fontSize /= s_d_scale;
	s_SetGWorld(s_drawingWindow,nil);
	GetFNum(s_fontName,&s_fontNum);
	TextFont(s_fontNum);
	TextSize(s_fontSize);

	s_SetGWorld(s_redrawWindow,s_display);
	TextFont(s_fontNum);
	TextSize(s_fontSize*s_d_scale);

	s_displayWindow = s_redrawWindow;

#ifdef NO_FORE_DRAW
	s_SetGWorld(s_drawingWindow,nil);
#endif

	s_redrawFlag = 1;

#else /*!S_UNIX*/

	s_ss.initDrawingFlag = 1;

	if (s_UNIX.drawingFlag)
	{
		if (!s_colorFlag)
			fprintf(s_UNIX.drawingFile, "Start();\n");
		else
			fprintf(s_UNIX.drawingFile, "StartColor();\n");
	}
	s_drawingBounds = s_windowBounds;
	s_drawingWindow = NewWindow(nil,&s_drawingBounds,
		"Drawing",true,altDBoxProc,
		(WindowPtr)-1L,true,0);

	s_displayWindow = s_redrawWindow = s_drawingWindow;

#endif /*else !S_UNIX*/
}

void s_NoRedrawInitDrawing()
{
#if !S_UNIX
short s_fontNum = 4;

	RedrawWindowP = &s_voidDummyVoid;

	if (s_colorFlag)
	{
		s_drawingWindow=NewCWindow(nil, &s_windowBounds,
			"\pDrawing", true, altDBoxProc, (WindowPtr)-1L, true, 0);
	}
	else
	{
		s_drawingWindow=NewWindow(nil,&s_windowBounds,
			"\pDrawing",true,altDBoxProc,(WindowPtr)-1L,true,0);
	}
	SetPort(GetWindowPort(s_drawingWindow));
	GetFNum(s_fontName,&s_fontNum);
	TextFont(s_fontNum);
	TextSize(s_fontSize);

	s_displayWindow = s_drawingWindow;
	s_redrawFlag = 0;
#else /*!S_UNIX*/

	UNIXStart();
	if (s_UNIX.drawingFlag)
	{
		if (!s_colorFlag)
			fprintf(s_UNIX.drawingFile, "Start();\n");
		else
			fprintf(s_UNIX.drawingFile, "StartColor();\n");
	}

#endif /*else !S_UNIX*/
}


void ShowDrawing(void)
{
#if !S_UNIX
	ShowWindow(s_redrawWindow);
	SelectWindow(s_redrawWindow);
#if defined(NO_REDRAW) || S_CARBON
#else
	RedrawWindow();
	SetPort(GetWindowPort(s_displayWindow));
#endif /*else defined(NO_REDRAW) || S_CARBON*/
#else /*S_UNIX*/
	if (s_UNIX.drawingFlag)
		fprintf(s_UNIX.drawingFile, "ShowDrawing();\n");
#endif /*else !S_UNIX*/
}

void HideDrawing(void)
{
#if !S_UNIX
#ifdef NO_REDRAW
	HideWindow(s_displayWindow);
#else /* def_NO_REDRAW */
	HideWindow(s_redrawWindow);
#endif
#else /*!S_UNIX*/
	if (s_UNIX.drawingFlag)
		fprintf(s_UNIX.drawingFile, "HideDrawing();\n");
#endif /*else !S_UNIX*/
}

void EraseDrawing(void)
{
Rect r0;

	SetRect(&r0, SCWindowBounds(s_displayWindow)->left/s_d_scale,
                 SCWindowBounds(s_displayWindow)->top/s_d_scale,
                 SCWindowBounds(s_displayWindow)->right/s_d_scale,
                 SCWindowBounds(s_displayWindow)->bottom/s_d_scale);
	EraseRect(&r0);
#if !S_UNIX && !S_CARBON
#ifndef NO_REDRAW
	s_RedrawWindow();
#endif
#endif /*!S_UNIX && !S_CARBON*/
}

#if !S_UNIX /******************** !!!! UNIX ********************/
/*#if !S_CARBON*/
CQDProcs s_GrafProcs;
void s_CustomizeQDProcs(void)
{
#if S_CARBON

    //grafProcs = GetPortGrafProcs(GetQDGlobalsThePort());
    //grafProcs->rgnProc = NewQDRgnUPP(s_CustomRgn);
    SetStdCProcs(&s_GrafProcs);
#if 1
	s_GrafProcs.textProc = NewQDTextUPP(s_CustomText);
	s_GrafProcs.lineProc = NewQDLineUPP(s_CustomLine);
	s_GrafProcs.rectProc = NewQDRectUPP(s_CustomRect);
	s_GrafProcs.rRectProc = NewQDRRectUPP(s_CustomRRect);
	s_GrafProcs.ovalProc = NewQDOvalUPP(s_CustomOval);
	s_GrafProcs.arcProc = NewQDArcUPP(s_CustomArc);
	s_GrafProcs.polyProc = NewQDPolyUPP(s_CustomPoly);
	s_GrafProcs.rgnProc = NewQDRgnUPP(s_CustomRgn);
	s_GrafProcs.bitsProc = NewQDBitsUPP(s_CustomBits);
#endif
    SetPortGrafProcs(GetQDGlobalsThePort(), &s_GrafProcs);
    return;
#else /*S_CARBON*/

	if (s_colorFlag)
	{
		//((CGrafPtr)s_redrawWindow)->grafProcs=(CQDProcsPtr)NewPtr(sizeof(CQDProcs));
		//SetStdProcs(s_redrawWindow->grafProcs);
	SetPortGrafProcs(GetWindowPort(s_redrawWindow), (CQDProcsPtr)NewPtr(sizeof(CQDProcs)));
		SetStdCProcs(GetPortGrafProcs(GetWindowPort(s_redrawWindow)));
#ifndef  NO_FORE_DRAW 
#if powerc
		((CGrafPtr)s_redrawWindow)->grafProcs->textProc = NewQDTextProc(s_CustomText);
		((CGrafPtr)s_redrawWindow)->grafProcs->lineProc = NewQDLineProc(s_CustomLine);
		((CGrafPtr)s_redrawWindow)->grafProcs->rectProc = NewQDRectProc(s_CustomRect);
		((CGrafPtr)s_redrawWindow)->grafProcs->rRectProc = NewQDRRectProc(s_CustomRRect);
		((CGrafPtr)s_redrawWindow)->grafProcs->ovalProc = NewQDOvalProc(s_CustomOval);
		((CGrafPtr)s_redrawWindow)->grafProcs->arcProc = NewQDArcProc(s_CustomArc);
		((CGrafPtr)s_redrawWindow)->grafProcs->polyProc = NewQDPolyProc(s_CustomPoly);
		((CGrafPtr)s_redrawWindow)->grafProcs->rgnProc = NewQDRgnProc(s_CustomRgn);
		((CGrafPtr)s_redrawWindow)->grafProcs->bitsProc = NewQDBitsProc(s_CustomBits);
		/* s_CustomTxMeas is buggy */
		/*((CGrafPtr)s_redrawWindow)->grafProcs->txMeasProc = NewQDTxMeasProc(s_CustomTxMeas);*/
#else
#ifdef THINK_C
#if THINK_C >= 7
#define QDPtr void* 
#endif 
		((CGrafPtr)s_redrawWindow)->grafProcs->textProc = (QDPtr)&s_CustomText;
		((CGrafPtr)s_redrawWindow)->grafProcs->lineProc = (QDPtr)&s_CustomLine;
		((CGrafPtr)s_redrawWindow)->grafProcs->rectProc = (QDPtr)&s_CustomRect;
		((CGrafPtr)s_redrawWindow)->grafProcs->rRectProc = (QDPtr)&s_CustomRRect;
		((CGrafPtr)s_redrawWindow)->grafProcs->ovalProc = (QDPtr)&s_CustomOval;
		((CGrafPtr)s_redrawWindow)->grafProcs->arcProc = (QDPtr)&s_CustomArc;
		((CGrafPtr)s_redrawWindow)->grafProcs->polyProc = (QDPtr)&s_CustomPoly;
		((CGrafPtr)s_redrawWindow)->grafProcs->rgnProc = (QDPtr)&s_CustomRgn;
		((CGrafPtr)s_redrawWindow)->grafProcs->bitsProc = (QDPtr)&s_CustomBits;
		/*((CGrafPtr)s_redrawWindow)->grafProcs->txMeasProc = (QDPtr)&s_CustomTxMeas;*/
#endif /* def THINK_C */
#ifdef __MWERKS__
		((CGrafPtr)s_redrawWindow)->grafProcs->textProc = (QDTextProcPtr)&s_CustomText;
		((CGrafPtr)s_redrawWindow)->grafProcs->lineProc = (QDLineProcPtr)&s_CustomLine;
		((CGrafPtr)s_redrawWindow)->grafProcs->rectProc = (QDRectProcPtr)&s_CustomRect;
		((CGrafPtr)s_redrawWindow)->grafProcs->rRectProc = (QDRRectProcPtr)&s_CustomRRect;
		((CGrafPtr)s_redrawWindow)->grafProcs->ovalProc = (QDOvalProcPtr)&s_CustomOval;
		((CGrafPtr)s_redrawWindow)->grafProcs->arcProc = (QDArcProcPtr)&s_CustomPoly;
		((CGrafPtr)s_redrawWindow)->grafProcs->rgnProc = (QDRgnProcPtr)&s_CustomRgn;
		((CGrafPtr)s_redrawWindow)->grafProcs->bitsProc = (QDBitsProcPtr)&s_CustomBits;
		/*((CGrafPtr)s_redrawWindow)->grafProcs->txMeasProc = (QDTxMeasProcPtr)&s_CustomTxMeas;*/
#endif /* def __MWERKS__ */
#endif /* else powerc */
#endif /* ndef  NO_FORE_DRAW */
	}
	else
	{
		//s_redrawWindow->grafProcs=(QDProcsPtr)NewPtr(sizeof(QDProcs));
		//SetStdProcs(s_redrawWindow->grafProcs);
	SetPortGrafProcs(GetWindowPort(s_redrawWindow), (CQDProcsPtr)NewPtr(sizeof(CQDProcs)));
		SetStdCProcs(GetPortGrafProcs(GetWindowPort(s_redrawWindow)));
#ifndef  NO_FORE_DRAW 
#if powerc
		s_redrawWindow->grafProcs->textProc = NewQDTextProc(s_CustomText);
		s_redrawWindow->grafProcs->lineProc = NewQDLineProc(s_CustomLine);
		s_redrawWindow->grafProcs->rectProc = NewQDRectProc(s_CustomRect);
		s_redrawWindow->grafProcs->rRectProc = NewQDRRectProc(s_CustomRRect);
		s_redrawWindow->grafProcs->ovalProc = NewQDOvalProc(s_CustomOval);
		s_redrawWindow->grafProcs->arcProc = NewQDArcProc(s_CustomArc);
		s_redrawWindow->grafProcs->polyProc = NewQDPolyProc(s_CustomPoly);
		s_redrawWindow->grafProcs->rgnProc = NewQDRgnProc(s_CustomRgn);
		s_redrawWindow->grafProcs->bitsProc = NewQDBitsProc(s_CustomBits);
		/*s_redrawWindow->grafProcs->txMeasProc = NewQDTxMeasProc(s_CustomTxMeas);*/
#else
#ifdef THINK_C
#if THINK_C >= 7
#define QDPtr void* 
#endif 
		s_redrawWindow->grafProcs->textProc = (QDPtr)&s_CustomText;
		s_redrawWindow->grafProcs->lineProc = (QDPtr)&s_CustomLine;
		s_redrawWindow->grafProcs->rectProc = (QDPtr)&s_CustomRect;
		s_redrawWindow->grafProcs->rRectProc = (QDPtr)&s_CustomRRect;
		s_redrawWindow->grafProcs->ovalProc = (QDPtr)&s_CustomOval;
		s_redrawWindow->grafProcs->arcProc = (QDPtr)&s_CustomArc;
		s_redrawWindow->grafProcs->polyProc = (QDPtr)&s_CustomPoly;
		s_redrawWindow->grafProcs->rgnProc = (QDPtr)&s_CustomRgn;
		s_redrawWindow->grafProcs->bitsProc = (QDPtr)&s_CustomBits;
		/*s_redrawWindow->grafProcs->txMeasProc = (QDPtr)&s_CustomTxMeas;*/
#endif /* def THINK_C */
#ifdef __MWERKS__
		s_redrawWindow->grafProcs->textProc = (QDTextProcPtr)&s_CustomText;
		s_redrawWindow->grafProcs->lineProc = (QDLineProcPtr)&s_CustomLine;
		s_redrawWindow->grafProcs->rectProc = (QDRectProcPtr)&s_CustomRect;
		s_redrawWindow->grafProcs->rRectProc = (QDRRectProcPtr)&s_CustomRRect;
		s_redrawWindow->grafProcs->ovalProc = (QDOvalProcPtr)&s_CustomOval;
		s_redrawWindow->grafProcs->arcProc = (QDArcProcPtr)&s_CustomArc;
		s_redrawWindow->grafProcs->polyProc = (QDPolyProcPtr)&s_CustomPoly;
		s_redrawWindow->grafProcs->rgnProc = (QDRgnProcPtr)&s_CustomRgn;
		s_redrawWindow->grafProcs->bitsProc = (QDBitsProcPtr)&s_CustomBits;
		/*s_redrawWindow->grafProcs->txMeasProc = (QDTxMeasProcPtr)&s_CustomTxMeas;*/
#endif /* def __MWERKS__ */
#endif /* else powerc */
#endif /* ndef  NO_FORE_DRAW */
	}
#endif /*else S_CARBON*/
}

#ifndef SCLLocal
#include <s_undef.c>
#else
#include "s_undef.c"
#endif

void s_RedrawWindow(void)
{
GWorldPtr currPort;
GDHandle currDev;
long bwForeColor, bwBackColor;
RGBColor cForeColor, cBackColor;
GrafPtr bwPort;
RgnHandle visibleRgn;

	if (s_colorFlag)
	{
		s_GetGWorld((GrafPtr*)&currPort,&currDev);
		//cForeColor = currPort->rgbFgColor;
		//cBackColor = currPort->rgbBkColor;
        GetPortForeColor(currPort, &cForeColor);
        GetPortBackColor(currPort, &cBackColor);
		s_SetGWorld(s_drawingWindow,nil);
		ForeColor(blackColor);
		BackColor(whiteColor);
//		LockPixels (((CGrafPtr)s_drawingWindow)->portPixMap);
		//CopyBits(&s_drawingWindow->portBits, &s_redrawWindow->portBits,
			//&s_redrawWindow->portRect, &s_redrawWindow->portRect, srcCopy, s_redrawWindow->visRgn);
		CopyBits(GetPortBitMapForCopyBits(GetWindowPort(s_drawingWindow)), 
            GetPortBitMapForCopyBits(GetWindowPort(s_redrawWindow)),
			SCWindowBounds(s_redrawWindow), SCWindowBounds(s_redrawWindow),
                srcCopy, GetPortVisibleRegion(GetWindowPort(s_redrawWindow),
                visibleRgn));
		s_SetGWorld((GrafPtr)currPort,currDev);
		RGBForeColor(&cForeColor);
		RGBBackColor(&cBackColor);
	}
	else
	{
		GetPort(&bwPort);
		//bwForeColor = (bwPort)->fgColor;
		//bwBackColor = (bwPort)->bkColor;
		GetPortForeColor(bwPort, &bwForeColor);
        GetPortBackColor(bwPort,&bwBackColor);
		SetPort(s_drawingWindow);
		ForeColor(blackColor);
		BackColor(whiteColor);
		//CopyBits(&s_drawingWindow->portBits, &s_redrawWindow->portBits,
			//&s_drawingVisRect, &s_redrawWindow->portRect, srcCopy, s_redrawWindow->visRgn);
		CopyBits(GetPortBitMapForCopyBits(GetWindowPort(s_drawingWindow)), 
            GetPortBitMapForCopyBits(GetWindowPort(s_redrawWindow)),
			SCWindowBounds(s_redrawWindow), SCWindowBounds(s_redrawWindow),
                srcCopy, GetPortVisibleRegion(GetWindowPort(s_redrawWindow),
                visibleRgn));
		SetPort(bwPort);
		ForeColor(bwForeColor);
		BackColor(bwBackColor);
	}
}
/*#endif /*!S_CARBON*/

#endif /*!S_UNIX*/ /******************** UNIX ********************/

void SetRGBColor(double r,double g,double b)
{
RGBColor c;

	c.red = r*65535.0/100.0;
	c.green = g*65535.0/100.0;
	c.blue = b*65535.0/100.0;
	s_RGBForeColor(&c);
}


#endif /*pragma once*/
