/*
 *  s_Pref.c
 *  Version 2.0 / 000920
 *  by Satoshi Takahashi
 */

#ifndef S_PREF_C /*pragma once*/
#define S_PREF_C
#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif
#if S_CARBON
#include <Carbon/Carbon.h>
#endif

#include <stdio.h>

#ifndef SCLLocal
#include <s_String.h>
#include <s_Pref.h>
#else
#include "s_String.h"
#include "s_Pref.h"
#endif


FILE *PrefFOpen(char *fName, char *fMode)
{
short vRefNum;
long dirID;
OSErr error;

	if (FindFolder(kOnSystemDisk, kPreferencesFolderType, kCreateFolder,
				&vRefNum, &dirID))
		return 0;
	
	if (HSetVol(NULL, vRefNum, dirID))
		return 0;
	
	return fopen(fName, fMode);
}


OSErr PrefGetAlias(char *fName, FSSpec *fssP)
{
short vRefNum;
long dirID;
OSErr error;
Str255 pFName;
Boolean isFolder;
Boolean wasAliased;

	error = FindFolder(kOnSystemDisk, kPreferencesFolderType, kCreateFolder,
				&vRefNum, &dirID);
	if (error)
		return error;

	C2PString(fName, pFName);
	error = FSMakeFSSpec(vRefNum, dirID, pFName, fssP);
	if (error) return error;
	
	return ResolveAliasFile(fssP, 1, &isFolder, &wasAliased);
}

#endif /*pragma once*/