/*
 *  s_Profile.c
 *  Version 1.5 / 971201
 *  by Satoshi Takahashi
 */

#ifndef S_PROFILE_C /*pragma once*/
#define S_PROFILE_C
#include <s_Config.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <s_Profile.h>
#include <s_Common.h>
#include <StartSCL.h>

int s_p_num;
long *s_p_time;
long *s_p_callNumber;
long *s_p_match;
char (*s_p_name)[64];

void SetUpProfile(int n)
{
int i;

	s_p_num = n;
	s_p_time = calloc(n, sizeof(long));
	s_p_callNumber = calloc(n, sizeof(long));
	s_p_match = calloc(n, sizeof(long));
	if (!(s_p_name = calloc(n, sizeof(char[64]))))
		s_OOMError();
	
	for (i = 0; i<n; i++)
	{
		sprintf(s_p_name[i],"%d",i);
	}
}

void SetProfileName(int i, char *name)
{
	if (i < s_p_num)
		strcpy(s_p_name[i],name);
	else
		s_printf("Error in SetProfileName:\n%d is too large.\n", i);
}

void StartProfile(int i)
{
	s_p_callNumber[i]++;
	s_p_match[i]++;
	s_p_time[i] -= TickCount();
}

void StopProfile(int i)
{
	s_p_time[i] += TickCount();
	s_p_match[i]--;
}

void PrintProfile(int stopFlag)
{
int i;

	s_printf("name:\ntime(s)    call number\n");

	for (i = 0; i<s_p_num; i++)
	{
		if (s_p_match[i])
			s_printf("%s:\ncalling unmatch\n", s_p_name[i]);
		else
			s_printf("%s:\n%.2f  %ld\n", s_p_name[i], s_p_time[i]/60.0, s_p_callNumber[i]);
	}
	
	if (stopFlag)
		Stop();
}

void ResetProfile(void)
{
int i;

	for (i = 0; i < s_p_num; i++)
	{
		s_p_time[i] = 0;
		s_p_callNumber[i] = 0;
		s_p_match[i] = 0;
	}
}

#endif /*pragma once*/