/*
 *  s_RedrawFunc.h
 *  Version 2.0 / 010910
 *  by Satoshi Takahashi
 */


#ifndef S_REDRAWFUNC_H /*pragma once*/
#define S_REDRAWFUNC_H

#ifndef SCLLocal
#include <s_Config.h>
#else
#include "s_Config.h"
#endif

#ifndef SCLLocal
#include <s_QDGlobal.h>
#else
#include "s_QDGlobal.h"
#endif

#if !S_UNIX /******************** !!!! UNIX ********************/

#endif /*!S_UNIX*/ /******************** UNIX ********************/

void s_MoveTo(int x, int y);
void s_Move(int x, int y);
#if S_CARBON
void	s_LineTo(int x, int y);
void	s_Line(int x, int y);
#endif
#if !S_UNIX /******************** !!!! UNIX ********************/

pascal void	s_CustomText(short n,Ptr text,Point num,Point denom);
pascal void	s_CustomLine(Point p);
pascal void	s_CustomRect(GrafVerb verb,Rect *r);
pascal void	s_CustomRRect(GrafVerb verb,Rect *r,short w,short h);
pascal void	s_CustomOval(GrafVerb verb,Rect *r);
pascal void	s_CustomArc(GrafVerb verb,Rect *r,short s,short a);
pascal void	s_CustomPoly(GrafVerb verb,PolyHandle h);
pascal void	s_CustomRgn(GrafVerb verb,RgnHandle h);
pascal void	s_CustomBits(BitMap *b,Rect *s,Rect *d,short m,RgnHandle r);
/* short s_CustomTxMeas(short byteCount, Ptr textAddr, Point *numer, Point *denom, FontInfo *info); */

void s_GlobalToLocal(Point *p);
#endif /*!S_UNIX*/ /******************** UNIX ********************/
void s_RectPath(Rect *rp);
void s_RoundRectPath(Rect* rp, short ovalWidth, short ovalHeight);
void s_OvalPath(Rect* rp);
void s_ArcPath(Rect *rp, short start, short arc, GrafVerb verb);
void s_PolyPath(PolyHandle h);
void s_DrawPSProc(GrafVerb verb);
void s_PSFillPat(void);

void s_ForeColor(long color);
void s_BackColor(long color);
void s_HidePen(void);
void s_ShowPen(void);
void s_SetPenState(PenState *pnState);
void s_PenSize(int width,int height);
#if !S_UNIX /******************** !!!! UNIX ********************/
void s_PenMode(int mode);
void s_PenPat(Pattern pat);
void s_PenNormal(void);
#endif /*!S_UNIX*/ /******************** UNIX ********************/
void s_SetPSText(short font, short size, Style face);
void s_SetPSFontFace(char *fontName, Style face);
void s_TextFont(short font);
void s_TextFace(Style face);
#if !S_UNIX /******************** !!!! UNIX ********************/
void s_TextMode(int mode);
#endif /*!S_UNIX*/ /******************** UNIX ********************/
void s_TextSize(short size);
#if !S_UNIX /******************** !!!! UNIX ********************/
void s_SpaceExtra(Fixed extra);
void s_FillArc(Rect*,short,short,Pattern);
#endif /*!S_UNIX*/ /******************** UNIX ********************/
void s_FillOval(Rect*,Pattern);
void s_FillPoly(PolyHandle,Pattern);
void s_FillRect(Rect*,Pattern);
#if !S_UNIX /******************** !!!! UNIX ********************/
void s_FillRgn(RgnHandle,Pattern);
void s_FillRoundRect(Rect*,short,short,Pattern);
void s_BackPat(Pattern pat);
#endif /*!S_UNIX*/ /******************** UNIX ********************/

void s_RGBForeColor( RGBColor *color);
void s_RGBBackColor( RGBColor *color);

#if !S_UNIX /******************** !!!! UNIX ********************/
pascal void s_SetCPixel(short x, short y,RGBColor *c);
void s_PenPixPat(PixPatHandle ppat);
void s_FillCArc(Rect*,short,short,PixPatHandle);
void s_FillCOval(Rect*,PixPatHandle);
void s_FillCPoly(PolyHandle,PixPatHandle);
void s_FillCRect(Rect*,PixPatHandle);
void s_FillCRgn(RgnHandle,PixPatHandle);
void s_FillCRoundRect(Rect*,short,short,PixPatHandle);
PicHandle s_OpenPicture(Rect *picRect);
void s_ClosePicture(void);
#endif /*!S_UNIX*/ /******************** UNIX ********************/
PolyHandle s_OpenPoly(void);
void s_ClosePoly(void);
#if !S_UNIX /******************** !!!! UNIX ********************/
void s_OpenRgn(void);
void s_CloseRgn(RgnHandle rh);

/* Other Redraw Functions */
void s_DrawPicture(PicHandle pict, Rect *rp);

#endif /*!S_UNIX*/ /******************** UNIX ********************/
#endif /*pragma once*/
